if(version$major == 3 && version$minor == 4) {
  mem.tally.report <- function(message) {
    value <- .C("S_tle_mem_tally_report",
                integer(2), integer(2), as.integer(2))[[2]]
    names(value) <- c("new database", "evaluation")
    if(!missing(message)) attr(value, "message") <- message
    class(value) <- "mem.tally"
    value
  }

  mem.tally.reset <- function()
    invisible(.C("S_tle_mem_tally_reset"))
}

resources <- function(expr) {
  loc <- sys.parent(1)
  if(loc == 1) loc <- F
  on.exit(cat("Timing stopped at:", proc.time() - time, "\n"))
  expr <- substitute(expr)
  stime <- proc.time()
  mem.tally.reset()
  w <- eval(expr, local = loc)
  etime <- proc.time()
  mem <- mem.tally.report()
  on.exit()
  names(mem) <- c("Cache", "Working")
  # proc.time() gives length 1 on Windows.
  if(length(stime) == 1) stime <- c(NA, NA, stime, 0, 0)
  if(length(etime) == 1) etime <- c(NA, NA, etime, 0, 0)
  time <- etime - stime
  time[3] <- max(time[3], time[1] + time[2])
  print(c(CPU = time[1] + time[2],
         Elapsed = time[3],
         "% CPU" = round((100 * (time[1] + time[2]))/time[3], 1),
         Child = time[4] + time[5], mem))
  invisible(w)
}
